<template>
  <q-page class="window-height window-width row justify-center items-center login-bg">
    <!--    style="background-color: #f6f6f6"-->
    <div class="column">
      <div class="row">
        <q-card flat class="q-pa-lg">
          <div class="row">
            <div class="col-12 text-center">
              <!-- <q-img class="" src="~assets/logo/logo.jpg" width="200px"/> -->
              <div class="text-xl">SYMTAC</div>
            </div>
            <!-- <div class="col-12 text-center text-bold">
              Ressources Humaines
            </div> -->
            <div class="col-12 text-center  q-mt-lg text-h6">
              {{forgottenPassword ? 'MOT DE PASSE OUBLIÉ' : 'CONNEXION'}}
            </div>
          </div>
          <ValidationObserver v-if="!forgottenPassword" v-slot="{ handleSubmit }">
            <q-form ref="FormSubmit" class="q-gutter-md" @submit="handleSubmit(onSubmit)">
              <q-card-section>
                <MField
                  main-design="standard"
                  label="Identifiant"
                  v-model="form.username"
                  autofocus
                  validation-rules="required"
                >
                </MField>
                <MField
                  label="Mot de passe"
                  validation-rules="required"
                  main-design="standard"
                  v-model="form.password"
                  :type-input="showPassword ? 'text' : 'password'"
                >
                  <template v-slot:mAppend>
                    <q-icon
                      :name="showPassword ? 'la la-eye' : 'la la-eye-slash'"
                      class="cursor-pointer"
                      color="blue-grey-3"
                      @click="showPassword = !showPassword"
                    />
                  </template>
                </MField>

              </q-card-section>
              <q-card-actions class="q-pt-none q-mt-none">
                <div class="col-12 q-px-sm">
                  <q-btn
                    flat text-color="secondary"
                    size="" class="full-width bg-accent"
                    type="submit"
                    label="Connexion"
                    :loading="loading"
                  >
                    <template v-slot:loading>
                      <q-spinner-hourglass class="on-left"></q-spinner-hourglass>
                      Veuillez patienter ...
                    </template>
                  </q-btn>
                </div>
              </q-card-actions>
              <q-card-section class="text-center q-pa-none">
                <q-btn @click="forgottenPassword = true" dense flat  class="text-grey-6">Mot de passe oublié ?</q-btn>
              </q-card-section>
            </q-form>
          </ValidationObserver>

          <ValidationObserver v-else v-slot="{ handleSubmit }">
            <q-form ref="ForgetPasswordFormSubmit" class="q-gutter-md" @submit="handleSubmit(onRequestNewPassword)">
              <q-card-section>
                <MField
                  main-design="standard"
                  label="Email"
                  v-model="form.username"
                  autofocus
                  validation-rules="required"
                >
                </MField>
              </q-card-section>
              <q-card-actions class="q-pt-none q-mt-none">
                <div class="col-12 q-px-sm">
                  <q-btn
                    flat text-color="secondary"
                    size="" class="full-width bg-accent"
                    type="submit"
                    label="Nouveau mot de passe"
                    :loading="loading"
                  >
                    <template v-slot:loading>
                      <q-spinner-hourglass class="on-left"></q-spinner-hourglass>
                      Veuillez patienter ...
                    </template>
                  </q-btn>
                </div>
              </q-card-actions>
              <q-card-section class="text-center q-pa-none">
                <q-btn @click="forgottenPassword = false" dense flat icon="la la-arrow-left"  class="text-grey-6" label="Retour à la page de connexion"/>
              </q-card-section>
            </q-form>
          </ValidationObserver>
        </q-card>
      </div>

    </div>
  </q-page>
</template>

<script>
import {mapActions, mapState} from "vuex";
import MField from "components/forms/MField";
import errorsHandler from "src/mixins/errors-handler";
import {ValidationObserver} from 'vee-validate';

export default {
  name: "LoginPage",
  components: {MField, ValidationObserver},
  mixins: [errorsHandler],
  data() {
    return {
      loading: false,
      showPassword: false,
      form: {
        username: '',
        password: null,
      },
      forgottenPassword: false
    }
  },
  methods: {

    async onSubmit() {
      try{
        this.loading = true
        await this.$store.dispatch('auth/login', this.form)
        this.Motify('success', 'Connection réussie!', this.$route.query.redirect|| '/')
      }catch (err){
        console.error('Error ', err)
        this.Motify('error', this._getErrorMessage(err), null, 4000)
      }finally {
        this.loading = false
      }
    },
    async onRequestNewPassword() {
      await this.$store.dispatch('auth/forgottenPasswordRequest', {email: this.form.username})
        .then(async () => {
          this.forgottenPassword = false
          return this.Motify('success', 'Veuillez vérifier votre boite mail!', null, 5000)
        }).catch(err => {
          this.Motify('error', this._getErrorMessage(err), null, 4000)
        })
    }

  },
  computed: {
    ...mapState({
      status: state => state.auth.status,
      currentUser: state => state.auth.user,
      roles: state => state.auth.roles
    })
  },
}
</script>

<style scoped>
.q-card {
  width: 360px;
}
</style>
